Index: branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 621)
@@ -372,5 +372,5 @@
 const Bool g_bEncDecTraceEnable  = true;
 const Bool g_bEncDecTraceDisable = false;
-Bool   g_HLSTraceEnable = false;
+Bool   g_HLSTraceEnable = true;
 Bool   g_bJustDoIt = false;
 UInt64 g_nSymbolCounter = 0;
Index: branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComRom.h
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComRom.h	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComRom.h	(revision 621)
@@ -198,5 +198,5 @@
 
 #ifndef ENC_DEC_TRACE
-# define ENC_DEC_TRACE 0
+#define ENC_DEC_TRACE   0
 #endif
 
Index: branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 621)
@@ -3826,15 +3826,4 @@
 }
 #endif
-#if SIGNAL_BITRATE_PICRATE_IN_VPS
-TComBitRatePicRateInfo::TComBitRatePicRateInfo()
-{
-  ::memset(m_bitRateInfoPresentFlag, 0, sizeof(m_bitRateInfoPresentFlag));
-  ::memset(m_picRateInfoPresentFlag, 0, sizeof(m_picRateInfoPresentFlag));
-  ::memset(m_avgBitRate,             0, sizeof(m_avgBitRate));
-  ::memset(m_maxBitRate,             0, sizeof(m_maxBitRate));
-  ::memset(m_constantPicRateIdc,     0, sizeof(m_constantPicRateIdc));
-  ::memset(m_avgPicRate,             0, sizeof(m_avgPicRate));
-}
-#endif
 //! \}
 
Index: branches/HTM-8.0-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 621)
@@ -698,5 +698,5 @@
 #endif
 #else
-    READ_UVLC ( uiCode, "sps_max_latency_increase");
+    READ_UVLC ( uiCode, "sps_max_latency_increase_plus1");
 #endif
     pcSPS->setMaxLatencyIncrease( uiCode, i );
Index: branches/HTM-8.0-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 621)
@@ -260,5 +260,5 @@
       else
       {
-        uiMergeIndex = pcCU->getMergeIndex(uiSubPartIdx); // Redundant line
+        uiMergeIndex = pcCU->getMergeIndex(uiSubPartIdx);
 #if H_3D_VSP
         Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
Index: branches/HTM-8.0-dev0/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 621)
@@ -3642,5 +3642,8 @@
 #if H_3D_VSP
   xRestrictBipredMergeCand( pcCU, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours,vspFlag, numValidMergeCand );
-#endif
+#else
+  xRestrictBipredMergeCand( pcCU, iPUIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
+#endif
+
 
   ruiCost = MAX_UINT;
Index: branches/HTM-8.0-dev0/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/HTM-8.0-dev0/source/Lib/TLibEncoder/TEncTop.cpp	(revision 620)
+++ branches/HTM-8.0-dev0/source/Lib/TLibEncoder/TEncTop.cpp	(revision 621)
@@ -515,5 +515,8 @@
   // mark it should be extended
   rpcPic->getPicYuvRec()->setBorderExtension(false);
+
+#if H_MV
   rpcPic->getPicYuvOrg()->setBorderExtension(false);
+#endif
 }
 
@@ -755,20 +758,5 @@
 #endif
   m_cPPS.setSignHideFlag(getSignHideFlag());
-#if L0386_DB_METRIC
-  if ( getDeblockingFilterMetric() )
-  {
-    m_cPPS.setDeblockingFilterControlPresentFlag (true);
-    m_cPPS.setDeblockingFilterOverrideEnabledFlag(true);
-    m_cPPS.setPicDisableDeblockingFilterFlag(false);
-    m_cPPS.setDeblockingFilterBetaOffsetDiv2(0);
-    m_cPPS.setDeblockingFilterTcOffsetDiv2(0);
-  } 
-  else
-  {
   m_cPPS.setDeblockingFilterControlPresentFlag (m_DeblockingFilterControlPresent );
-  }
-#else
-  m_cPPS.setDeblockingFilterControlPresentFlag (m_DeblockingFilterControlPresent );
-#endif
   m_cPPS.setLog2ParallelMergeLevelMinus2   (m_log2ParallelMergeLevelMinus2 );
   m_cPPS.setCabacInitPresentFlag(CABAC_INIT_PRESENT_FLAG);